//
//  LLCoreDataManager.h
//  LLJogTest
//
//  Created by Lawrence Lomax on 17/01/2010.
//  Copyright 2010 Lawrence Lomax. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

@interface LLCoreDataManager : NSObject {
    NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
    
}

+(LLCoreDataManager *)sharedLLCoreDataManager;

#pragma mark Core Data Stack Accessors
-(NSPersistentStoreCoordinator *)persistentStoreCoordinator;
-(NSManagedObjectModel *)managedObjectModel;
-(NSManagedObjectContext *)managedObjectContext;
-(NSString *)applicationDocumentsDirectory;

#pragma mark Context Management
-(NSManagedObject *)newObjectForName:(NSString *) entityName;
-(NSError *)saveContextChanges;

#pragma mark Fetch Requests
-(NSFetchRequest *)fetchRequestFromModelWithName:(NSString *)name;
-(NSFetchRequest *)fetchRequestFromModelWithName:(NSString *)name withSubstitutions:(NSDictionary *)substitutions;

#pragma mark Fetching Objects with Requests
-(NSArray *)objectsWithFetchRequest:(NSFetchRequest *)fetchRequest;
-(NSArray *)objectsWithEntityName:(NSString *)name withPredicate:(NSPredicate *)pred sortedWithDescriptors:(NSArray *)descriptors;
-(NSArray *)objectsWithEntityName:(NSString *)name sortedWithDescriptors:(NSArray *)descriptors;
-(NSArray *)objectsWithEntityName:(NSString *)name;
-(NSManagedObject *)firstObjectWithFetchRequest:(NSFetchRequest *)fetchRequest;
-(NSManagedObject *)firstObjectWithEntityName:(NSString *)name withPredicate:(NSPredicate *)pred sortedWithDescriptors:(NSArray *)descriptors;
-(NSManagedObject *)firstObjectWithEntityName:(NSString *)name sortedWithDescriptors:(NSArray *)descriptors;
-(NSManagedObject *)firstObjectWithEntityName:(NSString *)name;

@end
