//
//  NSObject+CommonObjects.h
//  LLJogTest
//
//  Created by Lawrence Lomax on 27/02/2010.
//  Copyright 2010 Lawrence Lomax. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "LLManagedObjects.h"

extern NSString * const twitterRequestsForIdentifier;
extern NSString * const twitterUsersForUsername;

@interface NSObject (LLCommonData) 

#pragma mark Twitter Requests
-(LLTwitterRequest *)twitterRequestWithIdentifier:(NSString *)requestIdentifier;

#pragma mark Twitter Users
-(LLTwitterUser *)twitterUserForUsername:(NSString *)username createIfAbsent:(BOOL)create;
-(NSArray *)followingTwitterUsersForUser:(LLTwitterUser *)user;
-(NSArray *)managedTwitterUsersFromDictionaries:(NSArray *)twitterUsers;

#pragma mark Twitter Statuses
-(NSArray *)managedTwitterStatusesFromDictionary:(NSArray *)tweets;

#pragma mark Journeys
-(LLJourney *)newJourneyStartingActive:(BOOL)startingActive;

#pragma mark GeoPoint
-(LLLocation *)lastBroadcastLocationForJourney:(LLJourney *)journey;


@end
