//
//  NSObject+CollectionsUtilities.m
//  LLJogTest
//
//  Created by Lawrence Lomax on 13/03/2010.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import "NSObject+CollectionsUtilities.h"


@implementation NSObject (CollectionsUtilities)

-(NSUInteger)numberOfSectionsInArrayMap:(NSArray *)array{
	return [array count];
}

-(NSUInteger)numberOfRowsInSectionsInArrayMap:(NSArray *)array withSectionNumber:(NSUInteger)sectionNumber{
	NSDictionary * sectionDictionary = [array objectAtIndex:sectionNumber];
	NSArray * values = [sectionDictionary allValues];
	NSArray * items = [values objectAtIndex:0];
	return [items count];
}

-(NSString *)sectionNameWithArrayMap:(NSArray *)array withSectionNumber:(NSUInteger)section{
	NSDictionary * sectionDictionary = [array objectAtIndex:section];
	NSArray * keys = [sectionDictionary allKeys];
	return [keys objectAtIndex:0];
}

-(NSString *)rowNameWithArrayMap:(NSArray *)array withSectionNumber:(NSUInteger)section withRowNumber:(NSUInteger)itemNumber{
	NSDictionary * sectionDictionary = [array objectAtIndex:section];
	NSArray * values = [sectionDictionary allValues];
	NSArray * items = [values objectAtIndex:0];
	return [items objectAtIndex:itemNumber];
}


@end
