//
//  LLTwitterController.h
//  MKTest
//
//  Created by Lawrence Lomax on 23/12/2009.
//  Copyright 2009 Lawrence Lomax. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

#import "MGTwitterEngine.h";
#import "LLHelperMacros.h"
#import "LLSendDelegate.h"
#import "LLTwitterDelegate.h"
#import "LLTwitterRequest.h"

extern NSString * const JogcastrHashtag;
extern NSString * const NotifyUsersStartRace;
extern NSString * const NotifyUsersEndRace;

#define FOLLOWING_UPDATE_INTERVAL 5.0

@interface LLTwitterController : NSObject<MGTwitterEngineDelegate> {
    id<LLTwitterDelegate> delegate;
    
    MGTwitterEngine *twitterEngine;
        
    NSTimer * updateCheckTimer;
}

#pragma mark Singleton Implementation
+(LLTwitterController *)sharedLLTwitterController;

#pragma mark User Credentials Methods
-(void)checkCurrentCredentials;
-(void)setCredentialsWithUsername:(NSString *)username withPassword:(NSString *)password;

#pragma mark Get User Info
-(void)getUsersFollowingAndAutoAddResults:(BOOL)results;
-(void)getUsersFollowing:(LLTwitterUser *)twitterUser autoAddResuults:(BOOL)addResults;

#pragma mark Tweets
-(void)getUpdatesForUser:(NSString *)username newerThanDate:(NSDate *)date autoAddResults:(BOOL)addResults;
-(void)getUpdatesForUser:(NSString *)username olderThanDate:(NSDate *)date autoAddResults:(BOOL)addResults;
-(void)getLatestUpdatesForUser:(NSString *)username;

#pragma mark Sending Updates Methods
-(void)sendLocationUpdate:(LLSendMessageModel *)message;

#pragma mark Recieving Updates Methods
-(void)stopViewingRunnerUpdates;
-(void)startViewingRunnerUpdates;

#pragma mark Timer Events Fired
-(void)checkForUpdates;
-(void)performRequest:(LLTwitterRequest *)req;

@property (nonatomic,retain) id<LLTwitterDelegate> delegate;

#pragma mark Private Methods for Twitter Controller

@end

@interface LLTwitterController(PrivateMethods)

-(void)setCredentialsFromStore;

@end