//
//  LLUserDefaults.h
//  LLJogTest
//
//  Created by Lawrence Lomax on 07/03/2010.
//  Copyright 2010 Lawrence Lomax. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "LLManagedObjects.h"

extern NSString * const UsernameKey;
extern NSString * const PasswordKey;
extern NSString * const JourneyIDKey;
extern NSString * const AutoRestartKey;
extern NSString * const CurrentUserKey;

@interface LLUserDefaults : NSObject{
	NSUserDefaults * userDefaults;
}

@property(nonatomic,readonly) NSUserDefaults * userDefaults;

+(LLUserDefaults *)sharedLLUserDefaults;

#pragma mark Credentials
-(NSDictionary *)storeCredentials;
-(void)setStoreCredentialsWithUsername:(NSString *)username withPassword:(NSString *)password;

#pragma mark Current User from Store
-(LLTwitterUserID *)currentTwitterUserID;
-(LLTwitterUser *)currentTwitterUser;
-(void)setCurrentTwitterUserID:(LLTwitterUserID *)userID;
-(void)setCurrentTwitterUser:(LLTwitterUser *)user;

#pragma mark Auto Restart
-(BOOL)autoRestartJourney;
-(void)setAutoRestartJourney:(BOOL)autoRestart;

#pragma mark Managed Objects Saving to and From User Defaults
-(NSManagedObjectID *)managedObjectIDWithKey:(NSString *)key;
-(NSManagedObject *)managedObject:(NSString *)key;
-(void)setManagedObjectID:(NSManagedObjectID *)objectID withKey:(NSString *)key;
-(void)setManagedObject:(NSManagedObject *)object withKey:(NSString *)key;

#pragma mark Active Journey
-(LLJourneyID *)activeJourneyID;
-(LLJourney *)activeJourney;
-(void)setActiveJourneyID:(LLJourneyID *)journeyID;
-(void)setActiveJourney:(LLJourney *)journey;


@end
