//
//  LLNewJourneyTableViewController.m
//  LLJogTest
//
//  Created by Lawrence Lomax on 13/03/2010

#import "LLNewJourneyTableViewController.h"
#import "NSObject+CollectionsUtilities.h"

NSString * const Naming_Section = @"Name";
NSString * const Broadcast_Section = @"Broadcast";

NSString * const Journey_Name_Row = @"Journey Name";

NSString * const Broadcast_To_Users_Row = @"Broadcast To Users";

@implementation LLNewJourneyTableViewController


#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];

	self.navigationItem.title = @"New Journey";
	
	NSDictionary * namingSection = [NSDictionary dictionaryWithObject:[NSArray arrayWithObjects:Journey_Name_Row,nil] forKey:Naming_Section];
	NSDictionary * broacastSection = [NSDictionary dictionaryWithObject:[NSArray arrayWithObjects:Broadcast_To_Users_Row,nil] forKey:Broadcast_Section];
	
	sectionsArray = [NSArray arrayWithObjects:namingSection,broacastSection,nil];
	[sectionsArray retain];
	
    // Uncomment the following line to preserve selection between presentations.
    //self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}
*/
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


#pragma mark -
#pragma mark Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return [self numberOfSectionsInArrayMap:sectionsArray];
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
    return [self numberOfRowsInSectionsInArrayMap:sectionsArray withSectionNumber:section];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
	}
	NSString * cellName = [self rowNameWithArrayMap:sectionsArray withSectionNumber:indexPath.section withRowNumber:indexPath.row];
	
	if(cellName == Journey_Name_Row){
		
	}
	
	if(cellName == Broadcast_To_Users_Row){
		cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	}
	
	
    // Configure the cell...
    
    return cell;
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*-(UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath{
	NSString * cellName = [self rowNameWithArrayMap:sectionsArray withSectionNumber:indexPath.section withRowNumber:indexPath.row];
	if(cellName == Journey_Name_Row){
		return UITableViewCellEditingStyle;
	}
}*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

//Sections heaers for Table View
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
	NSString * sectionName = [self sectionNameWithArrayMap:sectionsArray withSectionNumber:section];
	return sectionName;
}

#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	NSString * selectedSectionName = [self sectionNameWithArrayMap:sectionsArray withSectionNumber:indexPath.section];
	NSString * selectedRowName = [self rowNameWithArrayMap:sectionsArray withSectionNumber:indexPath.section withRowNumber:indexPath.row];
	
	if(selectedRowName == Broadcast_To_Users_Row){
		if(!twitterFollowingTableViewController){
			twitterFollowingTableViewController = [[LLTwitterFollowingTableViewController alloc] initWithNibName:@"TwitterFollowingTableView" bundle:[NSBundle mainBundle]];
		}
		[self.navigationController pushViewController:twitterFollowingTableViewController animated:YES];
	}
	
	// Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end

