//
//  LLTwitterAccountViewController.m
//  MKTest
//
//  Created by Lawrence Lomax on 23/12/2009.
//  Copyright 2009 Lawrence Lomax. All rights reserved.
//

#import "LLTwitterAccountViewController.h"
#import "LLNotificationStrings.h"
#import "LLUserDefaults.h"

@implementation LLTwitterAccountViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}


/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self setTitle:@"Twitter Account Options"];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(recieveNotification:) name:TwitterCredentialsValid object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(recieveNotification:) name:TwitterCredentialsInvalid object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(recieveNotification:) name:TwitterCredentialsChecking object:nil];
    
	NSDictionary * credentials = [[LLUserDefaults sharedLLUserDefaults] storeCredentials];
	[usernameField setText:[credentials objectForKey:UsernameKey]];
	[passwordField setText:[credentials objectForKey:PasswordKey]];
    
    twitterController = [LLTwitterController sharedLLTwitterController];
}

/*
// Override to allow orientations other than the default portrait orientation.  oke
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

-(IBAction)enterSettings{
    NSString * userName = [usernameField text];
    NSString * password = [passwordField text];
    [usernameField resignFirstResponder];
    [passwordField resignFirstResponder];
    [twitterController setCredentialsWithUsername:userName withPassword:password];
}

-(void)recieveNotification:(NSNotification *)notification{    
    if([[notification name] isEqualToString:TwitterCredentialsValid]){
        [statusLabel setText:@"Twitter Credentials Valid"]; 
        [activityIndicator stopAnimating];
        [usernameField setEnabled:YES];
        [passwordField setEnabled:YES];
        [saveButton setEnabled:YES];
		[[LLUserDefaults sharedLLUserDefaults] setStoreCredentialsWithUsername:[usernameField text] withPassword:[passwordField text]];
		//[twitterController getUsersFollowing:<#(LLTwitterUser *)twitterUser#> autoAddResuults:<#(BOOL)addResults#>
	}else if([[notification name] isEqualToString:TwitterCredentialsInvalid]){
        [statusLabel setText:@"Twitter Credentials Invalid"];
        [activityIndicator stopAnimating];
        [usernameField setEnabled:YES];
        [passwordField setEnabled:YES];
        [saveButton setEnabled:YES];
    }else if([[notification name] isEqualToString:TwitterCredentialsChecking]){
        [statusLabel setText:@"Checking Credentials are Valid..."];
        [activityIndicator startAnimating];
        [usernameField setEnabled:NO];
        [passwordField setEnabled:NO];
        [saveButton setEnabled:NO];
    }
}

-(void)viewWillDisappear:(BOOL)animated{
    [twitterController stopViewingRunnerUpdates];
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField{
	if(textField == usernameField){
		[usernameField resignFirstResponder];
		[passwordField becomeFirstResponder];
	}else if(textField == passwordField){
		[passwordField resignFirstResponder];
	}
	return YES;
}

- (void)dealloc {    
    [super dealloc];
}

@end
